package ukol.dotazy;

import java.awt.GridLayout;
import javax.swing.BoxLayout;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SpringLayout;

class UI {

    protected static Integer select(String title, int[] ids, String[] nazvy) {

        JComboBox list = new JComboBox(nazvy);

        int retval =
                JOptionPane.showConfirmDialog(null, list, title,
                JOptionPane.OK_CANCEL_OPTION);

        if (retval == JOptionPane.OK_OPTION) {
            int vybranyIndex = list.getSelectedIndex();
            if (vybranyIndex < 0) {
                JOptionPane.showMessageDialog(null,
                        "Nevybral(a) jste položku.");
                return null;
            } else {
                return ids[vybranyIndex];

            }
        } else {
            // uzivatel stiskl storno
            return null;
        }
    }

    protected static String getQuery(String title, String defaultQuery) {
        JTextArea area = new JTextArea(defaultQuery);
        area.setWrapStyleWord(true);
        area.setLineWrap(true);
        area.setColumns(30);
        area.setRows(7);

        JScrollPane pane = new JScrollPane(area);

        int retval =
                JOptionPane.showConfirmDialog(null, pane, title,
                JOptionPane.OK_CANCEL_OPTION);

        if (retval == JOptionPane.OK_OPTION) {
            String query = area.getText();
            if (query.trim().equals("")) {
                return null;
            }
            return query;
        } else {
            // uzivatel stiskl storno
            return null;
        }
    }

    static Author showAuthorDialog(String title, Author author) {
        AuthorPanel panel = new AuthorPanel(author);
        int retval =
                JOptionPane.showConfirmDialog(null, panel, title,
                JOptionPane.OK_CANCEL_OPTION);

        if (retval == JOptionPane.OK_OPTION) {
            return panel.getAuthor();
        } else {
            // uzivatel stiskl storno
            return null;
        }
    }

    private static class AuthorPanel extends JPanel {

        private JLabel label1 = new JLabel("First name: ");
        private JLabel label2 = new JLabel("Last name: ");
        private JTextField firstName;
        private JTextField lastName;
        private int id;

        private AuthorPanel(Author author) {
            firstName = new JTextField(author.firstName);
            lastName = new JTextField(author.lastName);
            id = author.id;
            label1.setLabelFor(firstName);
            label1.setDisplayedMnemonic('F');
            label2.setLabelFor(lastName);
            label2.setDisplayedMnemonic('L');
            setLayout(new GridLayout(2, 2, 5, 5));
            add(label1);
            add(firstName);
            add(label2);
            add(lastName);
        }

        public Author getAuthor() {
            return new Author(id, firstName.getText(), lastName.getText());
        }
    }

    static final class Author {

        public int id;
        public String firstName;
        public String lastName;

        Author(String firstName, String lastName) {
            this(-1, firstName, lastName);
        }

        Author(int id, String firstName, String lastName) {
            this.id = id;
            this.firstName = firstName;
            this.lastName = lastName;
        }
    }
}
